QOF: _QofBook Struct Reference

QOF 0.7.5

Data Fields
_QofBook Struct Reference
Query Object Framework » Object: Describing data structure. » Object_Private

`#include <qofbook-p.h>`

## Data Fields
QofInstance | inst
GHashTable * | hash_of_collections
GHashTable * | data_tables
GHashTable * | data_table_finalizers
gchar | book_open
gboolean | shutting_down
gint32 | version
QofBackend * | backend
QofUndo * | undo_data
guint32 | idata

## Detailed Description

Book structure

Definition at line 48 of file qofbook-p.h.

## Field Documentation

## ◆ backend

QofBackend* _QofBook::backend

To be technically correct, backends belong to sessions and not books. So the pointer below "really shouldn't be here", except that it provides a nice convenience, avoiding a lookup from the session. Better solutions welcome ...

Todo:
  allow book to lookup session and then backend.

Definition at line 87 of file qofbook-p.h.

## ◆ book_open

gchar _QofBook::book_open

state flag: 'y' means 'open for editing', 'n' means 'book is closed'

Todo:
  shouldn't this be replaced by the instance editlevel ?

Definition at line 70 of file qofbook-p.h.

## ◆ data_table_finalizers

GHashTable* _QofBook::data_table_finalizers

Hash table of destroy callbacks for the data table.

Definition at line 64 of file qofbook-p.h.

## ◆ data_tables

GHashTable* _QofBook::data_tables

In order to store arbitrary data, for extensibility, add a table that will be used to hold arbitrary pointers.

Definition at line 61 of file qofbook-p.h.

## ◆ hash_of_collections

GHashTable* _QofBook::hash_of_collections

The entity table associates the GUIDs of all the objects belonging to this book, with their pointers to the respective objects. This allows a lookup of objects based on their guid.

Definition at line 57 of file qofbook-p.h.

## ◆ idata

guint32 _QofBook::idata

Backend private expansion data used by the sql backend for kvp management

Definition at line 94 of file qofbook-p.h.

## ◆ inst

QofInstance _QofBook::inst

Unique guid for this book.

Definition at line 51 of file qofbook-p.h.

## ◆ shutting_down

gboolean _QofBook::shutting_down

a flag denoting whether the book is closing down, used to help the QOF objects shut down cleanly without maintaining internal consistency.

Todo:
  shouldn't shutting_down be replaced by instance->do_free?

Definition at line 77 of file qofbook-p.h.

## ◆ undo_data

QofUndo* _QofBook::undo_data

Undo support object

Definition at line 90 of file qofbook-p.h.

## ◆ version

gint32 _QofBook::version

version number, used for tracking multiuser updates

Definition at line 80 of file qofbook-p.h.

The documentation for this struct was generated from the following file:

- qofbook-p.h